using System;
using System.Collections.Generic;
using System.Linq;
using System.Net.Http.Headers;
using Maze;
using RESTAgent;
using Tavis;
using Tavis.Interfaces;
using RESTAgent.Maze;
using Tavis.Tools;

namespace MazeExplorer {
    class Program {
        static void Main(string[] args) {

            
            var restagent = new RestAgent();
            restagent.RegisterSemanticsProvider(new MazeSemanticsProvider());

			restagent.SetAcceptedMediaTypes( new[] { new MediaTypeWithQualityHeaderValue("application/vnd.amundsen.maze+xml") });
            
            var link = new Link("http://amundsen.com/examples/mazes/2d/five-by-five/");
            link.Accept = "application/vnd.amundsen.maze+xml";
            
            restagent.NavigateTo(link);

            var startlink = restagent.CurrentContent.GetLink<StartLink>();
            restagent.NavigateTo(startlink);

            // Pick first available door
            var firstlink = (from lk in restagent.CurrentContent.GetHeaderLinks() where !(lk is CurrentLink || lk is StartLink) select lk).First();
            restagent.NavigateTo(firstlink);

            var linkfrom = firstlink;

            while (restagent.CurrentContent.GetLink<ExitLink>() == null) {

                ILink chosenLink = null;
                var availablelinks = (from lk in restagent.CurrentContent.GetHeaderLinks() select lk).ToDictionary(lk => lk.Relation);

                switch(linkfrom.Relation) {
                    case "east":
                        chosenLink = ChooseDoor(availablelinks, "south", "east", "north", "west");
                        break;
                    case "west":
                        chosenLink = ChooseDoor(availablelinks, "north", "west", "south", "east");
                        break;
                    case "south":
                        chosenLink = ChooseDoor(availablelinks, "west", "south", "east", "north");
                        break;
                    case "north":
                        chosenLink = ChooseDoor(availablelinks, "east", "north", "west", "south");
                        break;

                }
                Console.WriteLine("Going : " + chosenLink.Relation);
                restagent.NavigateTo(chosenLink);
                linkfrom = chosenLink;
            }
            Console.WriteLine("Complete"); 
            Console.ReadLine();
        }
        private static ILink ChooseDoor(IDictionary<string, ILink> links, string option1, string option2, string option3, string option4) {
            
            if (links.ContainsKey(option1)) return links[option1];
            if (links.ContainsKey(option2)) return links[option2];
            if (links.ContainsKey(option3)) return links[option3];
            if (links.ContainsKey(option4)) return links[option4];
            return null;
        }

    }
}
