﻿using System;
using System.Collections.Generic;

namespace Tavis.Interfaces {
    public interface ILinkExtractor {
		/// <summary>The list of types that this link extractor knows how to extract links from</summary>
		IEnumerable<Type> SupportedTypes { get; }

		ILink GetLink(ILinkFactory factory, object content, string relation, string anchor = null);
		IEnumerable<ILink> GetLinks(ILinkFactory factory, object content, string relation = null, string anchor = null);
    }
}
