﻿using System.Collections;
using System.Collections.Generic;
using System.Linq;
using Tavis.Interfaces;

namespace Tavis {
    public class LinkHistory : IEnumerable<ILink>  {
        private readonly List<ILink> _Links = new List<ILink>();
        private const int _MaxStackSize = 10;

        public void AddToHistory(ILink link) {
            _Links.Add(link);
            if (_Links.Count > _MaxStackSize) {
                _Links.RemoveAt(0);
            }
        }

        public ILink CurrentLocation {
            get { return _Links.LastOrDefault(); }
        }

		public ILink PreviousLocation {
			get { return _Links.Count == 0 ? null : _Links.Last(); }
        }

		public void GoBack() {
			_Links.RemoveAt(_Links.Count - 1);
		}

        public IEnumerator<ILink> GetEnumerator() {
            return _Links.GetEnumerator();
        }

        IEnumerator IEnumerable.GetEnumerator() {
            return GetEnumerator();
        }
    }
}
