using System;
using System.IO;
using System.Net;
using System.Net.Http.Formatting;
using System.Net.Http.Headers;
using System.Threading.Tasks;
using HtmlAgilityPack;

namespace RESTAgent.Html {
    
    public class HtmlFormatter : MediaTypeFormatter {


        public HtmlFormatter() {
            SupportedMediaTypes.Add(new MediaTypeHeaderValue("text/html"));
        }


        protected override bool CanReadType(Type type)
        {
            return type == typeof(HtmlDocument);
        }
        protected override bool CanWriteType(Type type)
        {
            return false;
        }

        protected override Task<object> OnReadFromStreamAsync(Type type, Stream stream, HttpContentHeaders contentHeaders, FormatterContext formatterContext)
        {
            return new TaskFactory<object>().StartNew(() =>
            {
                var htmlDocument = new HtmlDocument();
                htmlDocument.Load(stream);
                return htmlDocument;
            });

        }

        protected override Task OnWriteToStreamAsync(Type type, object value, Stream stream, HttpContentHeaders contentHeaders, FormatterContext formatterContext, TransportContext transportContext)
        {
            throw new NotImplementedException();
            
        }


      
    }
}
